package jwars.control;

import jwars.net.Client;
import jwars.net.DefaultClientEventHandler;

/**
 * This class holds information about the set of players currently in the game.
 */
public class Community{

  /**
   * The one and only ClientEventHandler used in JWars.
   */
  public final static DefaultClientEventHandler players = new
      DefaultClientEventHandler();
  private static Client client;

  /**
   * This method is invoked when a player changes name or similar.
   */
  public static void playerPropertiesChanged(){
    if(client != null)
      client.fireClientPropertyChange();
  }

  /**
   * Sets the single Client which is running in this Session such that it can
   * be notified when players change properties.
   * @param client Client
   */
  public static void useClient(Client client){
    Community.client = client;
  }

  /*private final static List<PlayerPropertyChangeListener> listeners =
      new Vector<PlayerPropertyChangeListener>();

     public static void addPlayerPropertyChangeListener(PlayerPropertyChangeListener listener){
    listeners.add(listener);
     }

     public static void removePlayerPropertyChangeListener(PlayerPropertyChangeListener listener){
    listeners.remove(listener);
     }*/

  /*private final static JWarIOHandler<Player> playerPropertyChanger = new JWarIOHandler<Player>(){
    protected void read(DataInput input, int timeStamp) throws IOException{
      //This should be done ONLY if the game has not yet started.
      //Implement this later!
      //Otherwise it may lead to inconsistency what with players being on
      //different teams on different computers
      int identity = input.readInt();
      Player p = players.getPlayer(identity);
      p.setName(input.readUTF());
      p.setTeam(Teams.getTeamByShortName(input.readUTF()));
      for(PlayerPropertyChangeListener listener : listeners){
        listener.playerPropertyChanged(p);
      }
    }

    protected void echo(int clientIdentifier, DataInput input,
                        DataOutput output) throws IOException{
      output.writeInt(clientIdentifier);
      output.writeUTF(input.readUTF());
      output.writeUTF(input.readUTF());
    }

    protected void write(Player player, DataOutput output) throws IOException{
      output.writeUTF(player.getName());
      output.writeUTF(player.getTeam().NAME_SHORT);
    }

     };*/

  /*public static interface PlayerPropertyChangeListener {
    public void playerPropertyChanged(Player player);

     }*/

}
