package jwars.control;

import jwars.model.Unit;

/**
 * Implementing this interface and registering with a UnitSelectionModel
 * will allow objects to receive information about changes in the unit
 * selection.
 */
public interface UnitSelectionListener{

  /**
   * Invoked when a new unit is selected.
   * @param newSelection the newly selected unit
   * @param lastSelection the previously selected unit
   */
  public void unitSelected(Unit newSelection, Unit lastSelection);

}
