package jwars.data;

import java.util.ArrayList;
import java.util.Scanner;

import jwars.model.Formation;

public class FormationCategory extends UnitCategory {

  public final static String CATEGORY_NAME = "formation";
  private final ArrayList<UnitCategory> units = new ArrayList<UnitCategory>();

  public FormationCategory(Loader loader, Scanner input){
    super(loader, input);
    String next = input.next();
    if(!next.equals(Syntax.BLOCK_START)){
      throw new IllegalArgumentException("Syntax error. Expected: "+Syntax.BLOCK_START+". Found: "+next);
    }
    while(!(next = input.next()).equals(Syntax.TERMINATOR)){
      units.add(loader.getUnit(next));
    }
  }

  public Formation create(){
    Formation f = new Formation(this);
    for(UnitCategory cat : units){
      f.addUnit(cat.create());
    }
    return f;
  }

}
