package jwars.event.dynamic;

import jwars.test.Link;
import jwars.test.LinkList;

public class DEventQueue extends LinkList<DEvent>{

  private Schedule schedulator;
  private int currentTime;
  private int delay;

  public DEventQueue(Schedule schedulator, int delay){
    this.schedulator = schedulator;
    this.delay = delay;
  }

  public void update(int time){
    this.currentTime = time;
    Link<DEvent> link;
    DEvent e;
    while ((link = this.peek()) != null && (e=link.value()).delay == time){
      this.removeFirst();
      schedulator.reschedule(e);
    }

  }

  public void addLast(DEvent e){
    e.delay = currentTime + this.delay;
    super.addLast(e);
  }

}
