package jwars.gui.units;

import java.awt.Graphics2D;

public abstract class Sprite implements Drawable {

  public final static Sprite INVISIBLE = new Sprite(0){
    public void draw(Graphics2D g2d, int x, int y){}
  };

  boolean isDirty = true;
  int radius;

  /**
   * Creates a Sprite with a certain bounding radius
   * @param radius radius of bounding circle in pixels
   */
  public Sprite(int radius){
    this.radius = radius;
  }

  /**
   * Draw this Sprite
   * @param g2d Graphics2D
   * @param x int
   * @param y int
   */
  public abstract void draw(Graphics2D g2d, int x, int y);

  public void setDirty(boolean isDirty){
    this.isDirty = isDirty;
  }

  public boolean isDirty(){
    return isDirty;
  }

  public void setRadius(int radius){
    this.radius = radius;
  }

  public int getRadius(){
    return radius;
  }

}
