package jwars.model;

import java.awt.Graphics2D;

public abstract class DynamicSprite {

  World world;
  DynamicSprite next, previous;

  public abstract boolean draw(Graphics2D g, int x, int y, int time);

  public abstract int getX();
  public abstract int getY();

  public final DynamicSprite next(){
    return next;
  }

  protected final void destroy(){
    world.removeDynamicSprite(this);
  }

}
