package jwars.model.ai.impl;

import jwars.model.ai.MobileAI;
import java.util.Iterator;
import jwars.model.ai.ListeningAI;
import jwars.model.ai.Position;
import jwars.model.Unit;
import java.util.List;
import jwars.model.Coord;
import jwars.model.ai.ListeningAI;

public abstract class PathFindingAI
    extends MovementQueueAI {

  public PathFindingAI(Unit owner){
    super(owner);
  }

  public void orderMove(ListeningAI source, int x, int y){
    List<Coord> orderList = findPath(x,y);
    Coord c = orderList.get(1);
    super.orderMove(source, c.x, c.y);
    for(int i = 1; i < orderList.size(); i++){
      c = orderList.get(i);
      super.appendMove(source, c.x, c.y);
    }
    /*try{
      throw new Exception("test");
    } catch(Exception ex){
      ex.printStackTrace();
    }*/
  }

  public void appendMove(ListeningAI source, int x, int y){
    List<Coord> orderList = findPath(x,y);
    Coord c;
    for(int i = 1; i < orderList.size(); i++){
      c = orderList.get(i);
      super.appendMove(source, c.x, c.y);
    }
  }

  public void prependMove(ListeningAI source, int x, int y){
    List<Coord> orderList = findPath(x,y);
    Coord c;
    for(int i = orderList.size()-1; i >= 1; i--){
      c = orderList.get(i);
      super.prependMove(source, c.x, c.y);
    }
  }

  private List<Coord> findPath(int x, int y){
    return jwars.model.WarModel.WORLD.pathFinder.findPath(new
        Coord(x, y), owner);
  }

  /*protected void moveTowards(ListeningAI source, int x, int y){
    if(source == this){
      //Waypoints have already been set by the pathfinder
      super.moveTowards(source, x, y);
    } else {
      //Invoke pathfinder
   List<Coord> orderList = jwars.model.WarModel.WORLD.pathFinder.findPath(new
          Coord(x, y), owner);
      int lastIndex = orderList.size() - 1;
      Coord c;
      for(int i = lastIndex; i >= 1; i--){
        c = orderList.get(i);
        super.prependMove(this, c.x, c.y);
      }
    }
     }

     public String toString(){
    return "PFAI";
     }

     public void reportFinished(Object source){}
     public void reportFailed(Object source){}*/



  /*private static class X
      implements MobileAI{
    public Iterator iterator(){
      return null;
    }

    public void orderHalt(ListeningAI source){
    }

    public void setDestination(int x, int y){
    }

    public boolean isMoving(){
      return false;
    }

  }*/

}
