package jwars.model.map;

import java.util.Random;

import jwars.model.Coord;
import jwars.model.World;
import jwars.model.structures.BluePrint;
import jwars.model.structures.PolygonStructure;
import jwars.model.collision.*;


import jwars.model.Coord;
import jwars.model.World;
import jwars.model.structures.BluePrint;
import jwars.model.structures.PolygonStructure;
import jwars.model.structures.TerrainObject;
import java.awt.image.BufferedImage;
import java.awt.Graphics;
import jwars.model.WarModel;

public class StructureFactory{

  public static void buildDefaultStructure(World world){
    int width = 10;
    int height = 60;
    int pixelW = WarModel.WORLD.mainCoords.transformToCoords(WarModel.PIXEL_COORDS, world.metric(40));
    int pixelH = WarModel.WORLD.mainCoords.transformToCoords(WarModel.PIXEL_COORDS, world.metric(60));
 //   System.out.println("pixelW = "+pixelW+", pixelH = "+pixelH);

    BluePrint standard = new BluePrint(rectangle(world.metric(width), world.metric(height)), true);
    BufferedImage im = new BufferedImage(pixelW, pixelH ,java.awt.Transparency.OPAQUE);
    Graphics g = im.createGraphics();
    g.setColor(java.awt.Color.cyan);
    g.fillRect(pixelW/2, pixelH/2 , pixelW/2, pixelH/2);
    TerrainObject to = new TerrainObject(im, standard, 0, world.metric(1050), world.metric(1450));
    TerrainObject to2 = new TerrainObject(im, standard, 45/*45 radians!?*/, world.metric(1150), world.metric(1350));
    TerrainObject to3 = new TerrainObject(im, standard, 45, world.metric(1150), world.metric(1550));
    TerrainObject to4 = new TerrainObject(im, standard, 45, world.metric(1250), world.metric(1550));
 //   TerrainObject to2 = new TerrainObject(im, standard, 2, (580000), (15000));
    world.detector.register(to);
    world.detector.register(to2);
    world.detector.register(to3);
    world.detector.register(to4);

   // buildDefaultStructures(world);

  }

  public static void buildDefaultStructures(World world){
    int cityX = (int)(world.mainCoords.WIDTH * 0.42);
    int cityY = (int)(world.mainCoords.HEIGHT * 0.42);
    BluePrint[] prints = randomBluePrints(7, world.metric(20), world.metric(50));

    //int width = world.metric(40);
    //int height = world.metric(30);
    //PolygonStructure johnsHouse = new PolygonStructure(standardHouse(width,height), 1d, world.metric(200),world.metric(300));
    //world.DETECTOR.register(johnsHouse);
    //world.DETECTOR.register();
    //BluePrint[] prints = randomBluePrints
    TerrainObject[] city = city(prints, 16, cityX, cityY, world.metric(256));
    for(TerrainObject p : city){
      world.detector.register(p);
    }
  }

  private final static Random generator = new Random(1);
  //private final static int minSize = 10;
  //private final static int maxSize = 35;
  //private final static int spread = maxSize-minSize;

  public static Coord[] rectangle(int width, int height){
    Coord[] coords = new Coord[4];
    coords[0] = new Coord(-width/2,-height/2);
    coords[1] = new Coord(+width/2,-height/2);
    coords[2] = new Coord(+width/2,+height/2);
    coords[3] = new Coord(-width/2,+height/2);
    return coords;
  }

  public static BluePrint standardBluePrint(int width, int height){
    Coord[] coords = rectangle(width, height);
    return new BluePrint(coords, false);
  }

  public static TerrainObject[] city(BluePrint[] prints, int houseCount, int x, int y, int citySize){
    TerrainObject[] houses = new TerrainObject[houseCount];
    for(int i = 0; i<houses.length; i++){
      houses[i] = randomHouse(prints, x, y, citySize);
    }
    return houses;
  }

  public static TerrainObject randomHouse(BluePrint[] prints, int x, int y, int distance){
    double angle = generator.nextFloat()*2*Math.PI;
    int dist = generator.nextInt(distance);
    int structureX = x+(int)(dist*Math.cos(angle));
    int structureY = y+(int)(dist*Math.sin(angle));
    return new TerrainObject(null,
      prints[generator.nextInt(prints.length)],
      generator.nextFloat()*2*Math.PI,
      structureX,
      structureY);
  }

  public static BluePrint[] randomBluePrints(int count, int minSize, int maxSize){
    BluePrint[] prints = new BluePrint[count];
    for(int i = 0; i < prints.length; i++){
      prints[i] = randomBluePrint(minSize, maxSize);
    }
    return prints;
  }

  public static BluePrint randomBluePrint(int minSize, int maxSize){
    int spread = maxSize - minSize;
    return standardBluePrint(generator.nextInt(spread)+minSize, generator.nextInt(spread)+minSize);
  }

}


/*public class StructureFactory{

  public static void buildDefaultStructures(World world){
    int cityX = (int)(world.mainCoords.WIDTH * 0.32);
    int cityY = (int)(world.mainCoords.HEIGHT * 0.32);
    BluePrint[] prints = randomBluePrints(7, world.metric(10), world.metric(25));

    //int width = world.metric(40);
    //int height = world.metric(30);
    //PolygonStructure johnsHouse = new PolygonStructure(standardHouse(width,height), 1d, world.metric(200),world.metric(300));
    //world.DETECTOR.register(johnsHouse);
    //world.DETECTOR.register();
    //BluePrint[] prints = randomBluePrints
    PolygonStructure[] city = city(prints, 16, cityX, cityY, world.metric(256));
    for(PolygonStructure p : city){
      world.detector.register(p);
    }
  }

  private final static Random generator = new Random(1);
  //private final static int minSize = 10;
  //private final static int maxSize = 35;
  //private final static int spread = maxSize-minSize;

  public static Coord[] rectangle(int width, int height){
    Coord[] coords = new Coord[4];
    coords[0] = new Coord(-width/2,-height/2);
    coords[1] = new Coord(+width/2,-height/2);
    coords[2] = new Coord(+width/2,+height/2);
    coords[3] = new Coord(-width/2,+height/2);
    return coords;
  }

  public static BluePrint standardBluePrint(int width, int height){
    Coord[] coords = rectangle(width, height);
    return new BluePrint(coords, false);
  }

  public static PolygonStructure[] city(BluePrint[] prints, int houseCount, int x, int y, int citySize){
    PolygonStructure[] houses = new PolygonStructure[houseCount];
    for(int i = 0; i<houses.length; i++){
      houses[i] = randomHouse(prints, x, y, citySize);
    }
    return houses;
  }

  public static PolygonStructure randomHouse(BluePrint[] prints, int x, int y, int distance){
    double angle = generator.nextFloat()*2*Math.PI;
    int dist = generator.nextInt(distance);
    int structureX = x+(int)(dist*Math.cos(angle));
    int structureY = y+(int)(dist*Math.sin(angle));
    return new PolygonStructure(
      prints[generator.nextInt(prints.length)],
      generator.nextFloat()*2*Math.PI,
      structureX,
      structureY);
  }

  public static BluePrint[] randomBluePrints(int count, int minSize, int maxSize){
    BluePrint[] prints = new BluePrint[count];
    for(int i = 0; i < prints.length; i++){
      prints[i] = randomBluePrint(minSize, maxSize);
    }
    return prints;
  }

  public static BluePrint randomBluePrint(int minSize, int maxSize){
    int spread = maxSize - minSize;
    return standardBluePrint(generator.nextInt(spread)+minSize, generator.nextInt(spread)+minSize);
  }

}*/
