package jwars.model.structures;

/**
 * <p>q w</p>
 *
 * <p>q w</p>
 *
 * <p>e r</p>
 *
 * <p>r t</p> y u i o
 */
import jwars.model.Coord;
import jwars.model.pathfinder.PathFinder;

public class PathFindingNode extends Coord implements Comparable<PathFindingNode>{

  //Pathfinding variables
  private int g, h;
  public int f;
  public PathFindingNode ancestor;
  private PathFindingNode baby;

  private double indentDirectionX, indentDirectionY;
  private Coord indentedLocation = new Coord(this);

  public PathFindingNode(){
    super();
    reset();
  }

  public PathFindingNode(Coord c){
    super(c);
    reset();
  }

  /**
   * Resets the pathfindingnode
   */
  public void reset(){
    this.f = java.lang.Integer.MAX_VALUE;
    this.g = 0;
    this.h = java.lang.Integer.MAX_VALUE;
  }

  /**
   * update with a heuristic view.
   * h = distance travelled
   * g = distance to the final goal
   * f = g+h
   *
   * @param from PathFindingNode
   * @param goal Coord
   */
  public boolean update(PathFindingNode from, PathFindingNode goal){
    if(PathFinder.logging){
      System.out.println("From coord " + from.toString());
      System.out.println("Goal coord " + goal.toString());
      System.out.println("UPDATING NODE!");
    }
    int temp = from.h + this.dist(from);//distance(from, this);
    boolean succes = false;
    if(temp < h ){
      ancestor = from;
      h = temp;
      g = dist(goal);
      f = g+h;
      if(PathFinder.logging){
        System.out.println("The updated node  " + toString());
      }
      succes = true;
    }
    else if(PathFinder.logging){
      System.out.println("No node was NOT updated - shorter path found earlier ");
    }
    return succes;
  }

  public int compareTo(PathFindingNode other){
    return this.f - other.f;
  }

  public Coord calculateDestinationFromCorner(int radius){
  //  System.out.println("indentX = "+indentDirectionX+", indentY = "+indentDirectionY);
    int x = (int)(radius * indentDirectionX * 1.5);
    int y = (int)(radius * indentDirectionY * 1.5);
    this.indentedLocation.set(x,y);
    indentedLocation.plus(this);
   // System.out.println("calculated coord in PFN"+indentedLocation.toString());
    return this.indentedLocation;
  }

  public void setIndentDirection(double x, double y){
    indentDirectionX = x;
    indentDirectionY = y;
    //System.out.println("indetX : "+indentDirectionX+", indentY : "+indentDirectionY);
  }

  public void setBaby(PathFindingNode pfn){
    if(PathFinder.logging)
      System.out.println("Sat baby p en PFN");
    this.baby = pfn;
  }

  public Coord getIndented(){
    return indentedLocation;
  }

  public PathFindingNode getBaby(){
    return baby;
  }

  public String toString(){
    return " g = "+g+" f = "+f+" h = "+h+ " " +super.toString();
  }

  public void setHnull(){
    h = 0;
  }
}
