package jwars.test;

import jwars.synch.Timer;
import jwars.synch.TimerListener;

/**
 * Tests the Timer class using a certain delay.
 */
public class TimerTest
    implements TimerListener{

  private int delay = 100; //millis
  private long startTime;

  private Timer t;
  private int time;

  private int pauseTime;

  public TimerTest(){
    t = new Timer(delay);
    t.addTimerListener(this);
    startTime = System.currentTimeMillis();
    t.start();
  }

  public void reportStasis(){
    pauseTime++;
    if(pauseTime==40){
      System.out.println("Will unpause!");
      t.unpause();
    }
  }

  public void update(int frameCount, boolean isLate){
    time = frameCount * delay;
    if(time % 1000 == 0){
      long currentTime = System.currentTimeMillis() - startTime;
      System.out.println("Timer (ms): " + time + "\t System (ms): " +
                         currentTime + " \t Difference: " + (time - currentTime));
    }

    if(time == 4000){
      System.out.println("Will suspend!");
      t.suspend();
    } //if

  }

  public static void main(String[] args){
    TimerTest test = new TimerTest();
    /*try{
      Thread.sleep(2000);
         }
         catch(Exception ex){
      ex.printStackTrace();
         }
         System.out.println("Will suspend, sleep 3500!");
         test.t.suspend();
         try{
      Thread.sleep(3500);
         }
         catch(Exception ex){
      ex.printStackTrace();
         }
         System.out.println("3500 ms slept. Will pause!");

         System.out.println("Will pause, sleep 3500!");
         test.t.pause();
         try{
      Thread.sleep(3500);
         }
         catch(Exception ex){
      ex.printStackTrace();
         }
         System.out.println("Unpaused!");
         test.t.unpause();
     */
  }

}
