package jwars.test.explosions;

import java.util.List;
import java.awt.Graphics;

import java.awt.Image;
import java.util.Hashtable;

public abstract class ImpactAnimationType{

  public static void init(){
    //Now the static things have been initialized,
    //in case it is better to initialize now than at an unknown later time
  }

  public final static Hashtable<String, ImpactAnimationType> explosions =
      new Hashtable<String,ImpactAnimationType>();

  public final static ImpactAnimationType CRACKLE =
      new ExplosionType("smallburst", 5, 4, 14, 1, 15);
  public final static ImpactAnimationType BURST =
      new ExplosionType("mediumburst", 5, 4, 16, 3, 10);//new BulletType(8, 5, 10);
  public final static ImpactAnimationType BUUURST =
      new ExplosionType("bigburst", 5, 4, 20, 3, 30);

  //args: size, duration, spread, sparks per frame, duration
  public final static ImpactAnimationType TINY =
      new ExplosionType("tinyexplosion", 6, 5, 5, 16, 3);
  public final static ImpactAnimationType SMALL =
      new ExplosionType("smallexplosion", 10, 7,6, 16, 4);
  public final static ImpactAnimationType MEDIUM =
      new ExplosionType("mediumexplosion", 14,8, 8, 16, 5);
  public final static ImpactAnimationType LARGE =
      new ExplosionType("largeexplosion", 18,10, 10, 16, 5);
  public final static ImpactAnimationType HUGE =
      new ExplosionType("hugeexplosion",24, 14, 14, 16, 6);

  /*public ExplosionType(){
      int minSize = 8;
      int maxSize = 20;
      int minTime = 5;
      int maxTime = 10;

      int spread = 8;
      int sparksPerFrame = 16;
      int duration = 5;
      long seed = 0;

   ExplosionGenerator gen = new ExplosionGenerator(minSize, maxSize, minTime,
      maxTime);
   frames = gen.createRoundExplosion(spread, sparksPerFrame, duration, seed);
      length = frames.size();
     }*/


  public abstract boolean draw(Graphics g, int x, int y, int time);

  private static class ExplosionType
      extends ImpactAnimationType{

    private final List<Image> frames;
    public final int length;
    private long seed;

    public ExplosionType(String name, int defaultSparkSize, int sparkDuration,
                         int spread, int sparksPerFrame, int duration){
      int minSparkRadius = defaultSparkSize * 2 / 3;
      int maxSparkRadius = defaultSparkSize * 3 / 2;
      int minSparkDuration = sparkDuration * 2 / 3;
      int maxSparkDuration = sparkDuration * 3 / 2; //, int spread, int sparksPerFrame, int duration
      ExplosionGenerator gen = new ExplosionGenerator(minSparkRadius,
          maxSparkRadius, minSparkDuration, maxSparkDuration);
      frames = gen.createRoundExplosion(spread, sparksPerFrame, duration, seed++);
      length = frames.size();
      explosions.put(name, this);
    }

    public Image getImage(int time){
      if(time >= length){
        return null;
      } else{
        return frames.get(time);
      }
    }

    public boolean draw(Graphics g, int x, int y, int time){
      Image im = getImage(time);
      if(im != null){
        g.drawImage(im, x - im.getWidth(null) / 2, y - im.getHeight(null) / 2, null);
        return true;
      } else{
        return false;
      }
    }

  }

  /*private static class BulletType
      extends ImpactAnimationType{

    private int bulletCount, spread, duration;

    public BulletType(int bulletCount, int spread, int duration){
      this.bulletCount = bulletCount;
      this.spread = spread;
      this.duration = duration;
    }

    public boolean draw(Graphics g, int x, int y, int time){
      g.setColor(java.awt.Color.yellow);

      for(int i = 0; i < bulletCount; i++){
        g.drawLine();
      }
      return false;
    }

  }*/

}
